searchNodes=[{"doc":"Creates an instance of the movement and occupation sensor. Usage: defmodule MyApp.MySensor do use HcSr501Occupation.MovementSensor @impl HcSr501Occupation.MovementSensor def pin , do : 17 @impl HcSr501Occupation.MovementSensor def occupation_timeout , do : :timer . seconds ( 180 ) end Add to the supervision tree, eg defmodule MyApp.Application do use Application def start ( _type , _args ) do children = [ MyApp.MySensor ] opts = [ strategy : :one_for_one , name : MyApp.Supervisor ] Supervisor . start_link ( children , opts ) end end See README for full usage.","ref":"HcSr501Occupation.MovementSensor.html","title":"HcSr501Occupation.MovementSensor","type":"behaviour"},{"doc":"Implemented by the __using__ macro. The current occupation status: occupied or not and the last occupation event.","ref":"HcSr501Occupation.MovementSensor.html#c:occupation/0","title":"HcSr501Occupation.MovementSensor.occupation/0","type":"callback"},{"doc":"In milliseconds, how long after movement is no longer detected do we flip the state to unoccupied","ref":"HcSr501Occupation.MovementSensor.html#c:occupation_timeout/0","title":"HcSr501Occupation.MovementSensor.occupation_timeout/0","type":"callback"},{"doc":"GPIO Pin to which the sensor is attached","ref":"HcSr501Occupation.MovementSensor.html#c:pin/0","title":"HcSr501Occupation.MovementSensor.pin/0","type":"callback"},{"doc":"Implemented by the __using__ macro. Sets the occupation status. Provided for setting on reboot if the client has persisted the status somewhere. The status will be broadcast to all subscribers","ref":"HcSr501Occupation.MovementSensor.html#c:set_occupied/2","title":"HcSr501Occupation.MovementSensor.set_occupied/2","type":"callback"},{"doc":"Nerves , or similar, Elixir library for interfacing with a HC-SR501 passive infra-red motion sensor. It broadcasts to subscribing processes when movement is detected, no longer detected. Additionally it will broadcast when its operational area has not seen movement in long enough period for it to decide that the area has become occupied. Similarly it will broadcast when an area deemed unoccupied becomes occupied.","ref":"readme.html","title":"HcSr501 Occupation","type":"extras"},{"doc":"def deps do [ { :hc_sr_501_occupation , &quot;~&gt; 0.1.0&quot; } ] end","ref":"readme.html#installation","title":"HcSr501 Occupation - Installation","type":"extras"},{"doc":"Define the sensor in your project. An example is below: the HC-SR501 out pin is attached to GPIO pin 17; we deem the area monitored to be unoccupied after 3 minutes of no movement detection. defmodule Movement.Sensor do use HcSr501Occupation.MovementSensor @impl HcSr501Occupation.MovementSensor def pin , do : 17 @impl HcSr501Occupation.MovementSensor def occupation_timeout , do : :timer . seconds ( 180 ) end In your application (or other supervisor) include your module as a child: defmodule Movement.Application do use Application @impl true def start ( _type , _args ) do children = [ Movement.Sensor ] opts = [ strategy : :one_for_one , name : Movement.Supervisor ] Supervisor . start_link ( children , opts ) end end Note that the module's pin/0 and occoupation_timeout/0 are read at start; modifying the values after that point will have no impact without going in and killing processes. A processes can subscribe to receive a message when a movement event has occurred, with the subscribe/0 function that has been added to your module, eg MovementSensor . subscribe ( ) On subscription your process will receive an occupation message with its current state. If movement has been detected since startup, then the last movement detection will also be sent. Subsequent occupation and movement detection messages will also be sent to subscribed processes. Each message is a tuple, the first element of which is the name of your module - in our example Movement.Sensor The following messages can be received: Movement detected The HC-SR501 has detected movement and will send a message like { Movement.Sensor , :movement_detected , ~U[2023-02-01 12:34:40.883973Z] } The last element is the DateTime at which movement was detected. Movement stopped When the HC-SR501 stops detecting movement the following type of message will be sent to subscribers. { Movement.Sensor , :movement_stopped , ~U[2023-02-01 12:34:40.883973Z] } The last element is the DateTime at which the movement stopped signal was received. Occupied When we determine that a previously unoccupied are has become occupied, by detecting any movement, then the following form of message will be sent to subscribers { Movement.Sensor , :occupied , ~U[2023-02-01 12:34:40.883973Z] } By its nature this will always be preceeded by a :movement_detected message, with the same timestamp as in this message. Unoccupied An area is deemed unoccupied either at startup (of the process monitoring for occupation) or after no movement has been detected for the configured time when the area is deemed to have previously been occupied. When we determine that an area is unoccupied then subscribers will receive messages of the form { Movement.Sensor , :unoccupied , ~U[2023-02-01 12:34:40.883973Z] } The DateTime in a message received when starting up will be the startup time. The DateTime in a message caused by an occupied area being deemed to have become unoccupied, will be the time at which the last :unoccupied message was received. Setting the occupation status Should your project persist the occupation status, you might want to set it on startup with HcSr501Occupation.MovementSensor.set_occupied/2 .","ref":"readme.html#usage","title":"HcSr501 Occupation - Usage","type":"extras"},{"doc":"","ref":"changelog.html","title":"Changelog","type":"extras"},{"doc":"Initial","ref":"changelog.html#v0-1-0","title":"Changelog - v0.1.0","type":"extras"},{"doc":"Occupation status and time is writeable, so that this can be updated on boot.","ref":"changelog.html#v0-1-1","title":"Changelog - v0.1.1","type":"extras"},{"doc":"Occupation status directly readable.","ref":"changelog.html#v0-1-2","title":"Changelog - v0.1.2","type":"extras"}]